/*****************************************************************************/
/*  PROGRAMA PRINCIPAL                                                       */
/*                       Jose Miguel Benedi, 2009-2010 <jbenedi@dsic.upv.es> */
/*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "header.h"
#include "asin.h"
/************************************* Variables externas definidas en el AL */
extern FILE *yyin;
extern int  yylineno;
extern int  yydebug;
/********************************** Variables globales de uso en el "main.c" */
int verbosidad     = FALSE;     /* Flag para indicar si debe haber traza     */
int salida_binario = FALSE;     /* Flag para indicar si la salida es binaria */
int num_errores    = 0;	        /* Contador del numero de errores            */
char *nom_fich;                 /* Nombre del fichero de salida              */
/*****************************************************************************/
void yyerror (char *msg) 
/*  Funcion que gestiona el tratamiento de errores.                          */
{
  num_errores++;  
  if (verbosidad) printf("\n\n======> %s\n     ", msg); 
  else fprintf(stderr, "\nLinea %3d: %s\n", yylineno, msg);
}
/*****************************************************************************/
main (int argc, char **argv) 
/*  Programa principal. Gestiona la linea de comandos y llama al Analizador  */
/*  Sintactico.                                                              */
{
  --argc; ++argv;
  if ((argc == 1) || (argc == 2) || (argc == 3)){
    if (strcmp (argv[0], "-v") == 0){
      verbosidad = TRUE; --argc; ++argv;
    }
    else if (strcmp (argv[0], "-b") == 0){
      salida_binario = TRUE; --argc; ++argv;
    };
    if ((argc == 1) || (argc == 2)){
      if (strcmp (argv[0], "-v") == 0){
	verbosidad = TRUE; --argc; ++argv;
      }
      else if (strcmp (argv[0], "-b") == 0){
	salida_binario = TRUE; --argc; ++argv;
      };
      if (argc > 0){
	if ((yyin = fopen (argv[0], "r")) == NULL)
	  fprintf (stderr, "Fichero no valido %s\n", argv[0]);      
	else{
	  if (verbosidad == TRUE) printf("%3d.- ", yylineno);
          nom_fich = argv[0];
	  yyparse ();
	  if (num_errores == 0){
	    if (salida_binario == TRUE) vuelca_codigo_binario();
	    else  vuelca_codigo_ascii ();
	  }
	  else printf ("\nNumero de errores: %d\n", num_errores);
	}
      }	  
      else fprintf (stderr, "Uso: cmc [-v] [-b] fichero\n");
    }
    else fprintf (stderr, "Uso: cmc [-v] [-b] fichero\n");
  }
  else fprintf (stderr, "Uso: cmc [-v] [-b] fichero\n");
} 
/*****************************************************************************/
/*****************************************************************************/
