
%{
#include <stdlib.h>
#include "../virtual/definiciones.h"
#include "parser.h"

%}

%option yylineno
%option caseless
%option noyywrap

digito      [0-9]
nentero     "-"?{digito}+
nreal       {nentero}"."{digito}*
comen       "#"(.)*"\n"

%%	

{comen}   {                                                    }
" "       {                                                    }
"\t"      {                                                    }
esum      { return(ESUM_);                                     }
rsum      { return(RSUM_);                                     }
edif      { return(EDIF_);                                     }
rdif      { return(RDIF_);                                     }
emult     { return(EMULT_);                                    }
rmult     { return(RMULT_);                                    }
edivi     { return(EDIVI_);                                    }
rdivi     { return(RDIVI_);                                    }
resto     { return(RESTO_);                                    }
conv      { return(CONV_);                                     }
trunc     { return(TRUNC_);                                    }
esig      { return(ESIG_);                                     }
rsig      { return(RSIG_);                                     }
easig     { return(EASIG_);                                    }
rasig     { return(RASIG_);                                    }
gotos     { return(GOTOS_);                                    }
eigual    { return(EIGUAL_);                                   }
rigual    { return(RIGUAL_);                                   }
edist     { return(EDIST_);                                    }
rdist     { return(RDIST_);                                    }
emen      { return(EMEN_);                                     }
rmen      { return(RMEN_);                                     }
emay      { return(EMAY_);                                     }
rmay      { return(RMAY_);                                     }
emayeq    { return(EMAYEQ_);                                   }
rmayeq    { return(RMAYEQ_);                                   }
emeneq    { return(EMENEQ_);                                   }
rmeneq    { return(RMENEQ_);                                   }
eav       { return(EAV_);                                      }
rav       { return(RAV_);                                      }
eva       { return(EVA_);                                      }
rva       { return(RVA_);                                      }
eread     { return(EREAD_);                                    }
rread     { return(RREAD_);                                    }
ewrite    { return(EWRITE_);                                   }
rwrite    { return(RWRITE_);                                   }
cread     { return(CREAD_);                                    }
cwrite    { return(CWRITE_);                                   }
fin       { return(FIN_);                                      }
ret       { return(RET_);                                      }
call      { return(CALL_);                                     }
nop       { return(NOP_);                                      }
epush     { return(EPUSH_);                                    }
rpush     { return(RPUSH_);                                    }
epop      { return(EPOP_);                                     }
rpop      { return(RPOP_);                                     }
pushfp    { return(PUSHFP_);                                   }
fppop     { return(FPPOP_);                                    }
fptop     { return(FPTOP_);                                    }
topfp     { return(TOPFP_);                                    }
inctop    { return(INCTOP_);                                   }
dectop    { return(DECTOP_);                                   }
"\n"      { return(NLIN_);                                     }
","       { return(COMA_);                                     }
"r:"      { return(REAL_);                                     }
"e:"      { return(ETIQ_);                                     }
"p:"      { return(POSI_);                                     }
"i:"      { return(ENTE_);                                     }
"("       { return(A_PAR_);                                    }
")"       { return(C_PAR_);                                    }
{nentero} { yylval.ent = atoi(yytext); return(CTEN_);          }
{nreal}   { yylval.real = (float) atof(yytext); return(CTRE_); }
.         { yyerror("Error lexico");                           }

%%

