%{
/*****************************************************************************/
/**  Analizador Sintactico de ficheros C3D                                  **/
/*****************************************************************************/
#include <stdio.h>
#include "../virtual/definiciones.h"

extern struct tipo_ctd *g_vector_salida;
extern int *n_l_leidas;
extern int error_max_leidas;

%}
%union
{
  float              real;
  int                ent;
  struct tipo_arg    argumento;
  struct tipo_ctd    inst3dir;  
}
%token 
ESUM_ RSUM_ EDIF_ RDIF_ EMULT_ RMULT_ EDIVI_ RDIVI_ RESTO_ CONV_ TRUNC_ ESIG_
RSIG_ EASIG_ RASIG_ GOTOS_ EIGUAL_ RIGUAL_ EDIST_ RDIST_ EMEN_ RMEN_ EMAY_
RMAY_ EMAYEQ_ RMAYEQ_ EMENEQ_ RMENEQ_ EAV_ RAV_ EVA_ RVA_ EREAD_ RREAD_
EWRITE_ RWRITE_ CREAD_ CWRITE_ FIN_ RET_ CALL_ NOP_ EPUSH_ RPUSH_ EPOP_ RPOP_
PUSHFP_ FPPOP_ FPTOP_ TOPFP_ INCTOP_ DECTOP_ NLIN_ COMA_ REAL_ ETIQ_
POSI_ ENTE_ A_PAR_ C_PAR_
%token<ent>      CTEN_ 
%token<real>     CTRE_
%type<argumento> arg_posi_ente arg_posi_real arg_ente arg_real arg_posi arg_etiq
%type<ent> inst_ip_ip_p inst_rp_rp_p inst_ip_ip_e inst_rp_rp_e inst_ip_n_p
%type<ent> inst_rp_n_p inst_n_n_e inst_n_n_p inst_n_n_ip inst_n_n_rp inst_n_n_n
%type<ent> inst_n_n_i inst_p_ip_p inst_p_ip_ip inst_p_ip_rp
%type<inst3dir> instruccion

%%

lista_ordenes : lista_ordenes CTEN_ instruccion NLIN_ 
                  {  if(*n_l_leidas < MAXCODE){
                       g_vector_salida[*n_l_leidas].lin = $2;
                       g_vector_salida[*n_l_leidas].cop = $3.cop;
                       g_vector_salida[*n_l_leidas].arg[0].tipo = $3.arg[0].tipo;
		       g_vector_salida[*n_l_leidas].arg[0].i_pos = $3.arg[0].i_pos;
		       g_vector_salida[*n_l_leidas].arg[0].niv = $3.arg[0].niv;
		       g_vector_salida[*n_l_leidas].arg[0].r = $3.arg[0].r;
                       g_vector_salida[*n_l_leidas].arg[1].tipo = $3.arg[1].tipo;
		       g_vector_salida[*n_l_leidas].arg[1].i_pos = $3.arg[1].i_pos;
		       g_vector_salida[*n_l_leidas].arg[1].niv = $3.arg[1].niv;
		       g_vector_salida[*n_l_leidas].arg[1].r = $3.arg[1].r;
                       g_vector_salida[*n_l_leidas].arg[2].tipo = $3.arg[2].tipo;
		       g_vector_salida[*n_l_leidas].arg[2].i_pos = $3.arg[2].i_pos;
		       g_vector_salida[*n_l_leidas].arg[2].niv = $3.arg[2].niv;
		       g_vector_salida[*n_l_leidas].arg[2].r = $3.arg[2].r;
                       (*n_l_leidas)++;
                     }else{
                       if(error_max_leidas == 0){
                         yyerror("Se ha sobrepasado el numero maximo de instrucciones en el programa\n");
                         error_max_leidas = 1;
                       }
                     }
		  } | lista_ordenes NLIN_ | lista_ordenes error NLIN_ |;

arg_real : REAL_ CTRE_ { $$.tipo = ARG_REAL; $$.r = $2; };

arg_ente : ENTE_ CTEN_ { $$.tipo = ARG_ENTERO; $$.i_pos = $2; } ;

arg_posi : POSI_ A_PAR_ CTEN_ COMA_ CTEN_ C_PAR_
             { if($3 != 0 && $3 != 1) yyerror("Error en el argumento posicion: El primer valor solo puede ser 0 o 1\n");
	       $$.tipo = ARG_POSICION; $$.i_pos = $5; $$.niv = $3; } ;

arg_etiq : ETIQ_ CTEN_ 
             { if($2 < 0 || $2 >= MAXCODE) yyerror("Error en el argumento etiqueta. Apunta a una posicion no valida\n");
               $$.tipo = ARG_ETIQUETA; $$.i_pos = $2; } ;

arg_posi_ente : arg_posi { $$ = $1; } | arg_ente { $$ = $1; } ;
	       
arg_posi_real : arg_posi { $$ = $1; } | arg_real { $$ = $1; } ;

instruccion : inst_ip_ip_p arg_posi_ente COMA_ arg_posi_ente COMA_ arg_posi      { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_rp_rp_p arg_posi_real COMA_ arg_posi_real COMA_ arg_posi      { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_ip_ip_e arg_posi_ente COMA_ arg_posi_ente COMA_ arg_etiq      { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_rp_rp_e arg_posi_real COMA_ arg_posi_real COMA_ arg_etiq      { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_ip_n_p  arg_posi_ente COMA_               COMA_ arg_posi      { $$.cop = $1; $$.arg[0] = $2;                 $$.arg[2] = $5; } |
              inst_rp_n_p  arg_posi_real COMA_               COMA_ arg_posi      { $$.cop = $1; $$.arg[0] = $2;                 $$.arg[2] = $5; } |
              inst_n_n_e                 COMA_               COMA_ arg_etiq      { $$.cop = $1;                                 $$.arg[2] = $4; } |
              inst_n_n_p                 COMA_               COMA_ arg_posi      { $$.cop = $1;                                 $$.arg[2] = $4; } |
              inst_n_n_ip                COMA_               COMA_ arg_posi_ente { $$.cop = $1;                                 $$.arg[2] = $4; } |
              inst_n_n_rp                COMA_               COMA_ arg_posi_real { $$.cop = $1;                                 $$.arg[2] = $4; } |
              inst_n_n_n                 COMA_               COMA_               { $$.cop = $1;                                                 } |
              inst_n_n_i                 COMA_               COMA_ arg_ente      { $$.cop = $1;                                 $$.arg[2] = $4; } |
              inst_p_ip_p  arg_posi      COMA_ arg_posi_ente COMA_ arg_posi      { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_p_ip_ip arg_posi      COMA_ arg_posi_ente COMA_ arg_posi_ente { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } |
              inst_p_ip_rp arg_posi      COMA_ arg_posi_ente COMA_ arg_posi_real { $$.cop = $1; $$.arg[0] = $2; $$.arg[1] = $4; $$.arg[2] = $6; } ;

inst_ip_ip_p : ESUM_ { $$ = ESUM; } | EDIF_ { $$ = EDIF; } | EMULT_ { $$ = EMULT; } | EDIVI_ { $$ = EDIVI; } | RESTO_ { $$ = RESTO; } ;
inst_rp_rp_p : RSUM_ { $$ = RSUM; } | RDIF_ { $$ = RDIF; } | RMULT_ { $$ = RMULT; } | RDIVI_ { $$ = RDIVI; } ;
inst_ip_ip_e : EIGUAL_ { $$ = EIGUAL; } | EDIST_ { $$ = EDIST; } | EMEN_ { $$ = EMEN; } | EMAY_ { $$ = EMAY; } | EMAYEQ_ { $$ = EMAYEQ; } | EMENEQ_ { $$ = EMENEQ; } ;
inst_rp_rp_e : RIGUAL_ { $$ = RIGUAL; } | RDIST_ { $$ = RDIST; } | RMEN_ { $$ = RMEN; } | RMAY_ { $$ = RMAY; } | RMAYEQ_ { $$ = RMAYEQ; } | RMENEQ_{ $$ = RMENEQ; } ;
inst_ip_n_p: CONV_ { $$ = CONV; } | ESIG_ { $$ = ESIG; } | EASIG_ { $$ = EASIG; } ;
inst_rp_n_p : TRUNC_ { $$ = TRUNC; } | RSIG_ { $$ = RSIG; } | RASIG_ { $$ = RASIG; } ;
inst_n_n_e : GOTOS_ { $$ = GOTOS; } | CALL_ { $$ = CALL; } ;
inst_n_n_p : EREAD_ { $$ = EREAD; } | RREAD_ { $$ = RREAD; } | CREAD_ { $$ = CREAD; } | EPOP_ { $$ = EPOP; } | RPOP_ { $$ = RPOP; } ;
inst_n_n_ip: EWRITE_ { $$ = EWRITE; } | CWRITE_ { $$ = CWRITE; } | EPUSH_ { $$ = EPUSH; } | INCTOP_ { $$ = INCTOP; } | DECTOP_{ $$ = DECTOP; } ;
inst_n_n_rp : RWRITE_ { $$ = RWRITE; } | RPUSH_ { $$ = RPUSH; } ;
inst_n_n_n : FIN_ { $$ = FIN; } | RET_ { $$ = RET; } | PUSHFP_ { $$ = PUSHFP; } | FPPOP_ { $$ = FPPOP; } | FPTOP_ { $$ = FPTOP; } | TOPFP_ { $$ = TOPFP; } ;
inst_n_n_i : NOP_ { $$ = NOP; } ;
inst_p_ip_p : EAV_ { $$ = EAV; } | RAV_ { $$ = RAV; } ;
inst_p_ip_ip : EVA_ { $$ = EVA; } ;
inst_p_ip_rp : RVA_ { $$ = RVA; } ;

%%

