#include <QtGui>
#include "introducircaracterej.h"


// El dialogo de introducir caracter permite introducir mediante una caja de texto con un validador
// un caracter cuyo codigo ASCII se encuentre entre el 32 y el 126.
// El unico valor que interesa del dialogo es edi.text().at(0).toAscii(), que pasa el valor ascii del
// primer caracter de la caja editora. Todos los casos que pueden provocar error estan previstos.
// Si para salir del dialogo se usa reject() en vez de accept() podemos emplearlo para parar el programa.

IntroducirCaracterEj::IntroducirCaracterEj(QWidget *padre) : QDialog(padre){
    
    eti = new QLabel(tr("Introducir un &caracter"));
    edi = new QLineEdit;
    edi->setValidator(new QRegExpValidator(QRegExp ("[\\x0020-\\x007E]"), this));
    eti->setBuddy(edi);
    acep = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogOkButton)), tr("&Aceptar"));
    acep->setEnabled(false);
    canc = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogCancelButton)), tr("Cancelar"));

    connect(acep, SIGNAL(clicked()), this, SLOT(accept()));
    connect(canc, SIGNAL(clicked()), this, SLOT(reject()));
    connect(edi, SIGNAL(textChanged(const QString &)), this, SLOT(on_edi_textChanged()));
    
    QHBoxLayout *escribir = new QHBoxLayout;
    escribir->addWidget(eti);
    escribir->addWidget(edi);
    QHBoxLayout *botones = new QHBoxLayout;
    botones->addStretch();
    botones->addWidget(acep);
    botones->addWidget(canc);
    QVBoxLayout *ventana = new QVBoxLayout;
    ventana->addLayout(escribir);
    ventana->addLayout(botones);
    setLayout(ventana);
    setWindowTitle("Falspas");
}

void IntroducirCaracterEj::on_edi_textChanged(){
  
    acep->setEnabled(edi->hasAcceptableInput());
}

