#include <QtGui>
#include "introducirenteroej.h"


// El dialogo de introducir un entero permite introducir mediante una caja de texto con un validador
// un numero entero, tanto positivo como negativo.
// El unico valor que interesa del dialogo es edi.text().toInt(), que pasa el valor entero representado por el
// QString de la caja editora. Todos los casos que pueden provocar error estan previstos.
// Si para salir del dialogo se usa reject() en vez de accept() podemos emplearlo para parar el programa.

IntroducirEnteroEj::IntroducirEnteroEj(QWidget *padre) : QDialog(padre) {
  
    eti = new QLabel(tr("Introducir un &entero"));
    edi = new QLineEdit;
    edi->setValidator(new QIntValidator(-1000000, 1000000, this));
    eti->setBuddy(edi);
    acep = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogOkButton)), tr("&Aceptar"));
    acep->setEnabled(false);
    canc = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogCancelButton)), tr("Cancelar"));    
    
    connect(acep, SIGNAL(clicked()), this, SLOT(accept()));
    connect(canc, SIGNAL(clicked()), this, SLOT(reject()));
    connect(edi, SIGNAL(textChanged(const QString &)), this, SLOT(on_edi_textChanged()));
    
    QHBoxLayout *escribir = new QHBoxLayout;
    escribir->addWidget(eti);
    escribir->addWidget(edi);
    QHBoxLayout *botones = new QHBoxLayout;
    botones->addStretch();
    botones->addWidget(acep);
    botones->addWidget(canc);
    QVBoxLayout *ventana = new QVBoxLayout;
    ventana->addLayout(escribir);
    ventana->addLayout(botones);
    setLayout(ventana);
    setWindowTitle("Falspas");
}

void IntroducirEnteroEj::on_edi_textChanged(){
  
    acep->setEnabled(edi->hasAcceptableInput());
}
