#include <QtGui>
#include "introducirrealej.h"


// El dialogo de introducir un real permite introducir mediante una caja de texto con un validador
// un real en el rango +-1.000.000, empleando la notacion normal o cientifica.
// El unico valor que interesa del dialogo es edi.text().at(0).toFloat(), que pasa el valor real representado por
// el QString de la caja editora. Todos los casos que pueden provocar error estan previstos.
// Si para salir del dialogo se usa reject() en vez de accept() podemos emplearlo para parar el programa.

IntroducirRealEj::IntroducirRealEj(QWidget *padre) : QDialog(padre) {
        
    eti = new QLabel(tr("Introducir un &real"));
    edi = new QLineEdit;
    eti->setBuddy(edi);
    acep = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogOkButton)), tr("&Aceptar"));
    acep->setEnabled(false);
    canc = new QPushButton(QIcon(style()->standardPixmap(QStyle::SP_DialogCancelButton)), tr("Cancelar"));
    edi->setValidator(new QDoubleValidator(-1000000.0, 1000000.0, 3, this));

    connect(acep, SIGNAL(clicked()), this, SLOT(accept()));
    connect(canc, SIGNAL(clicked()), this, SLOT(reject()));
    connect(edi, SIGNAL(textChanged(const QString &)), this, SLOT(on_edi_textChanged()));
    
    QHBoxLayout *escribir = new QHBoxLayout;
    escribir->addWidget(eti);
    escribir->addWidget(edi);
    QHBoxLayout *botones = new QHBoxLayout;
    botones->addStretch();
    botones->addWidget(acep);
    botones->addWidget(canc);
    QVBoxLayout *ventana = new QVBoxLayout;
    ventana->addLayout(escribir);
    ventana->addLayout(botones);
    setLayout(ventana);
    setWindowTitle("Falspas");
}

void IntroducirRealEj::on_edi_textChanged(){
  
    acep->setEnabled(edi->hasAcceptableInput());
}
