#ifndef PRINCIPAL_H
#define PRINCIPAL_H

#include <QtGui>
#include "definiciones.h"

struct st_posmem {
    int i_e_pos;
    bool niv;
};

union un_arg {
    float r;
    st_posmem i_e_pos_niv;
};

struct st_arg {
    t_cod_arg tipo_arg;
    un_arg dato;
};

struct t_fpo_des {
    int p, refe;
};

union un_mem {
    int i;
    float r;
    t_fpo_des fpo_des;
};

class c_tipo_ctd {
public:
    c_tipo_ctd();
    t_cod_ins r_cop();
    bool r_brp();
    error_mem r_arg(int p_arg, t_cod_arg *p_cod);
    error_mem r_int(int p_arg, int *p_val);
    error_mem r_eti(int p_arg, int *p_val);
    error_mem r_pos(int p_arg, bool *p_niv, int *p_pos);
    error_mem r_rea(int p_arg, float *p_fval);
    void s_cop(t_cod_ins p_cop);
    void s_brp(bool p_brp);
    error_mem s_int(int p_arg, int p_val);
    error_mem s_eti(int p_arg, int p_val);
    error_mem s_pos(int p_arg, bool p_niv, int p_pos);
    error_mem s_rea(int p_arg, float p_fval);
    void setnull();
    error_mem setnull(int p_arg);
private:
    t_cod_ins cop;
    int nlinea;
    bool breakpoint;
    st_arg v_arg[3];
};

class c_tipo_mem {
public:
    c_tipo_mem();
    tipo_mem r_tip();
    error_mem r_int(int *p_val);
    error_mem r_rea(float *p_fval);
    error_mem r_fpo(int *p_val, int *p_refe);
    error_mem r_des(int *p_val, int *p_refe);
    void s_int(int p_val);
    void s_rea(float p_fval);
    void s_fpo(int p_val, int p_refe);
    void s_des(int p_val, int p_refe);
    void reset();
private:
    tipo_mem t;
    un_mem celda;
};

class Principal : public QMainWindow {
    Q_OBJECT
public:
    Principal();
private slots:
    void abrir();
    void recargar();
    void ejecutar();
    void siguientepaso();
    void parar();
    void borrarbreakpoints();
    void cambiapilaestricta();
    void acerca();
    void ayuda();
    void desplazavisor();
    void activarbp(QTreeWidgetItem * item, int column);
    void opciones();
    void compilar();
    void editar();
private:
    void closeEvent(QCloseEvent *event);
    void escribeconf();
    void leeconf();
    void cargar(QString nombrearchivo);
    void ej_inst(c_tipo_ctd *inst_exe, bool muestra, error_mem *err, int *salto);
    void escribir_warnings(error_mem *err, int inst_act);
    void set_dir_fisicas();
    
    error_mem escribe_mem(int narg, c_tipo_ctd *inst, int val, bool p_muestra, tipo_mem tipo_dato = MEM_INT, int de_inst = 0); //int ins int bool mem int
    error_mem escribe_mem(int narg, c_tipo_ctd *inst, float fval, bool p_muestra);                                             //int ins float bool
    error_mem escribe_mem(bool niv, int posi, int val, bool p_muestra, tipo_mem tipo_dato = MEM_INT, int de_inst = 0);         //bool int int bool mem int
    error_mem escribe_mem(bool niv, int posi, float fval, bool p_muestra);                                                     //bool int float bool
    error_mem escribe_mem(int pos_abs, int val, bool p_muestra, tipo_mem tipo_dato = MEM_INT, int de_inst = 0);                //int int bool mem int
    error_mem escribe_mem(int pos_abs, float fval, bool p_muestra);                                                            //int float bool
    error_mem leer_mem(int narg, c_tipo_ctd *inst, int *val, tipo_mem tipo_dato = MEM_INT);                                    //int ins int mem
    error_mem leer_mem(int narg, c_tipo_ctd *inst, float *fval);                                                               //int ins float
    error_mem leer_mem(bool niv, int pos, int *val, tipo_mem tipo_dato = MEM_INT);                                             //bool int int mem
    error_mem leer_mem(bool niv, int pos, float *fval);                                                                        //bool int float
    error_mem leer_mem(int pos_abs, int *val, tipo_mem tipo_dato = MEM_INT);                                                   //int int mem
    error_mem leer_mem(int pos_abs, float *fval);                                                                              //int float
    error_mem recupera_op(int narg, c_tipo_ctd *inst, int *val, tipo_mem tipo_dato = MEM_INT);                                 //int ins int mem
    error_mem recupera_op(int narg, c_tipo_ctd *inst, float *fval);                                                            //int ins float
    error_mem recupera_op(int narg, c_tipo_ctd *inst, bool *niv, int *pos);                                                    //int ins bool int
    error_mem set_top(int n_top, bool p_muestra);
    error_mem set_fp(int n_fp, bool p_muestra);
 
    QLabel *textobarra;
    QString ficheroactual, ruta_editor, ruta_compilador;

    QMenu *menufichero, *menuejecutar, *menuopciones, *menuayuda;
    QToolBar *barraarchivo, *barraejecutar, *barraayuda;

    QAction *accionabrir, *accionrecargar, *accionejecutar, *accionsiguientepaso, *accionparar, *accionpilaestricta;
    QAction *accionsalir, *accionacerca, *accionborrarbreakpoints, *accionayuda, *acciondesplazavisor, *accionopciones;
    QAction *accioncompilar, *accioneditar; 

    QSplitter *splitterprincipal, *splitterderecho, *splitterizquierdo;
    QTreeWidget *tree_inst, *tree_mem;
    QTextEdit *textosalida, *textoerrores;

    QList<QTreeWidgetItem *> rep_inst, rep_mem;
    QList<c_tipo_ctd *> list_inst;
    QList<c_tipo_mem *> list_mem;

    QStringList textcodes;

    int totalbp, total_inst, inst_actual, ult_escr, p_top, p_fp;
    bool muestra_excepciones, desp_mem, pila_estricta;
};

#endif
