#include <QtGui>
#include "principal.h"
#include "introducircaracterej.h"
#include "introducirrealej.h"
#include "introducirenteroej.h"


// Este metodo ejecuta el programa instruccion a instruccion.

void Principal::siguientepaso(){
  
    int salto;
    error_mem err[MAXERRVEC];
        
    //Desactivamos la accion y quitamos el icono de la instruccion actual
    accionparar->setEnabled(true);
    rep_inst.at(inst_actual)->setIcon(0, QIcon());
    
    //Borramos la marca de la posible ultima instruccion que haya escrito algo
    if(ult_escr != -1) for(int i = 0; i < 6; i++) rep_mem.at(ult_escr)->setBackground(i, QBrush(Qt::NoBrush));
    
    ej_inst(list_inst.at(inst_actual), true /*Debe modificarse la representacion*/, err, &salto);
    escribir_warnings(err, inst_actual);
    
    //Modificamos el P.C. segun la variable salto
    switch(salto){
      case -3: //Se acabo el programa bien con una instruccion FIN
	textoerrores->append(QString("El programa ha finalizado correctamente\nPara volverlo a ejecutar debe reiniciarlo"));
	rep_inst.at(inst_actual)->setIcon(0, QIcon(style()->standardPixmap(QStyle::SP_ArrowRight)));
	accionparar->setEnabled(true);
	accionabrir->setEnabled(true);
	accionrecargar->setEnabled(true);
	accioncompilar->setEnabled(true);
	accioneditar->setEnabled(true);
	accionejecutar->setEnabled(false);
	accionsiguientepaso->setEnabled(false);
	break; //Debemos desactivar las acciones paso a paso, ejecutar y recuperar la memoria
      case -2:
	break;
      case -1:
	inst_actual++; break; //No era una instruccion de salto
      default:
	inst_actual = salto; break; //Es un salto
    }
    
    //Comprobamos que el PC este en una posicion valida
    if(inst_actual >= total_inst || inst_actual < 0){
      textoerrores->append(QString("Error. Ha modificado el P.C. a una posicion que no existe en su programa (%1)\nProbablemente su programa no funcione correctamente\nDebe reiniciarlo para continuar").arg(inst_actual));
      accionparar->setEnabled(true);
      accionabrir->setEnabled(true);
      accionrecargar->setEnabled(true);
      accioncompilar->setEnabled(true);
      accioneditar->setEnabled(true);
      accionejecutar->setEnabled(false);
      accionsiguientepaso->setEnabled(false);
    }
    
    //Las direcciones fisicas se modifican en set_fp, el sombreado en el acceso a memoria
    //Volvemos a dibujar la flecha de instruccion acutal
    if(inst_actual < total_inst && inst_actual >= 0)rep_inst.at(inst_actual)->setIcon(0, QIcon(style()->standardPixmap(QStyle::SP_ArrowRight)));
    if(inst_actual < total_inst && inst_actual >= 0 && desp_mem)tree_inst->scrollToItem(rep_inst.at(inst_actual));
    
} //Fin Metodo
